<?php

require_once('/usr/fallback/beroConf.php');

/**
 * Implementiert hilfreiche Funktionen die überall benutzt werden können
 * @author Miguel Palmer <mp@beronet.com>
 * @author Florian Kraatz <fk@beronet.com>
 */
class Helper {

	/**
	 * Gateway neustarten
	 */
	public static function reboot($url) {
		/* rck wird ausgeführt, wenn rck nach 10 Sekunden
		 * nicht richtig beendet wurde, wird rcK gestoppt und die Karte wird
		 * neugestartet. Per AJAX wird geprüft ob die Karte wieder UP ist, die
		 * Loginseite wird dann wieder angezeigt.
		 */
		$handle = popen('/bin/sh /etc/init.d/rcK', 'r');
		$i = 0;
		while (!feof($handle) && $i++ != 10) {
			sleep(1);
		}
		pclose($handle);
		print("<script type='text/javascript'>
			window.setTimeout('setRequest()',5000);
                    </script>");
		exec('/usr/bin/killall rcK');
		flush();
		exec('/sbin/reboot');
		exit();
	}

	/**
	 *  Funktion für das Löschen eines Moduls und der entsprechenden Dialplaneinträge,
	 * wenn die Belegung der Line Interfaces sich ändert
	 */
	public static function deleteModul($li, $name, $table) {
		$ba = new beroAri();


		//CAS channels und Dialplan Einträge löschen löschen.
		if ($table == "cas") {
			$query = $ba->select("select port from $table where lif='" . sqlite_escape_string($li) . "' and type='" . sqlite_escape_string($name) . "'");
			while ($entry = $ba->fetch_array($query)) {
				$query = $ba->select("select * from cas_channels where port='" . $entry['port'] . "'");
				while ($ent = $ba->fetch_array($query)) {
					$ba->delete("delete from dialplan where fromDirection='" . sqlite_escape_string($table) . "' and fromId='g:" . $ent['gr'] . "'");
					$ba->delete("delete from dialplan where fromDirection='" . sqlite_escape_string($table) . "' and fromId='" . $ent['channel'] . "'");
					$ba->delete("delete from dialplan where toDirection='" . sqlite_escape_string($table) . "' and toId='g:" . $ent['gr'] . "'");
					$ba->delete("delete from dialplan where toDirection='" . sqlite_escape_string($table) . "' and toId='" . $ent['channel'] . "'");
				}
				$ba->delete("delete from cas_channels where port='" . $entry["port"] . "'");
			}
			//Dialplan Einträge aller anderen Technologien löschen
		} else {
			$query = $ba->select("select * from " . sqlite_escape_string($table) . " where lif='" . sqlite_escape_string($li) . "' and type='" . sqlite_escape_string($name) . "'");
			while ($entry = $ba->fetch_array($query)) {
				$ba->delete("delete from dialplan where fromDirection='$table' and fromId='g:" . $entry['gr'] . "'");
				$ba->delete("delete from dialplan where fromDirection='$table' and fromId='" . $entry['port'] . "'");
				$ba->delete("delete from dialplan where toDirection='$table' and toId='g:" . $entry['gr'] . "'");
				$ba->delete("delete from dialplan where toDirection='$table' and toId='" . $entry['port'] . "'");
			}
		}
		$ba->delete("delete from " . sqlite_escape_string($table) . " where lif='" . sqlite_escape_string($li) . "' and type='" . sqlite_escape_string($name) . "'");


		$ba->set('portswitch', 0);

		$q = $ba->select("SELECT type, lif FROM isdn union SELECT type, lif FROM analog union SELECT type, lif FROM gsm order by lif");
		$i = 0;
		while ($ent = $ba->fetch_array($q)) {
			$lif[$i] = $ent['lif'];
			$type[$i] = $ent['type'];
			$i++;
		}

		$revision = self::getRevision();
		if (($type[0] == "bf4S0" || $type[0] == "bf2S02FXS" || $type[0] == "bf4FXS" || $type[0] == "bf4FXO") && !isset($type[1]) && $revision != "1.80" && $revision != "1.8") {
			$ba->set('portswitch', 1);
		}

		$option = $ba->get("activate");
		if ($option <= 3)
			$query = $ba->set('activate', '3');
		echo "<script>aktivieren(1,'state','3','" . ACTIVATE . "');</script>";
	}

	/**
	 * Funktion für das Löschen von Call progress tablea,
	 * wenn die Belegung der Line Interfaces sich ändert
	 */
	public static function deleteCPT($dir) {
		//echo $li.$name.$table;
		$ba = new beroAri();
		$query = $ba->select("select * from callprogress where direction='" . sqlite_escape_string($dir) . "'");
		while ($entry = $ba->fetch_array($query)) {
			$ba->delete("delete from callprogress_entries where id_name='" . $entry['id'] . "'");
		}
		$ba->delete("delete from callprogress where direction='" . sqlite_escape_string($dir) . "'");
	}

	/**
	 *  Fügt in die Datenbank ein neues Modul hinzu
	 */
	public static function createModul($setPortSwitch = false) {

		$ba = new beroAri();

		if ($setPortSwitch == true)
			$ba->set("portswitch", 0);
		$queries_li1 = $ba->add_module_db(1, 0, 0);

		if (!empty($queries_li1)) {
			foreach ($queries_li1 as $query) {
				$ba->exec_query($query);
			}
			unset($queries_li1);
		}

		if ($ba->is_error()) {
			echo '<script>alert(\'' . $ba->error() . '\');</script>';
		}

		$option = $ba->get("activate");
		if ($option <= 3)
			$query = $ba->set('activate', '3');
	}

	/**
	 * Generiert ein Array mit den ISDN ports
	 * @return array
	 */
	public static function getIsdnPorts() {
		//Ein neues Datenbankobjekt wird erzeugt.
		$ba = new beroAri();
		//ISDN Ports suchen
		$qu = $ba->select("select port from isdn");
		$result = array();
		while ($entry = $ba->fetch_array($qu)) {
			array_push($result, $entry['port']);
		}
		return $result;
	}

	/**
	 * Generiert ein Array mit den neuesten verfügbaren Software Versionen
	 */
	public static function getAvailableFwVersion() {

		$url = 'ftp://appliance.beronet.com/beronet_gateway/firmware_3LI.list';

		if (!($lines = @file($url))) {
			return(false);
		}

		foreach ($lines as $line) {
			if (($line == "\n") || ($line[0] == '#')) {
				continue;
			}

			$tmp = explode(';', trim($line, "\n\t"));

			$ret[] = array('name' => $tmp[0]);
			break;
		}

		return($ret);
	}

	/**
	 * Activate button anzeigen
	 */
	public static function activate($option, $show = false, $m = "", $text = "activate") {
		//Ein neues Datenbankobjekt wird erzeugt.
		$ba = new beroAri();
		//ISDN Ports suchen
		$optionSaved = $ba->get("activate");
		if ($optionSaved <= $option) {
			$query = $ba->set('activate', $option);
			if ($show)
				return "<script>aktivieren(1,'" . $m . "','" . $option . "','" . $text . "','" . $_GET['opt'] . "');</script>";
		}
	}

	/**
	 * Activate option der API speichern
	 */
	public static function activateApi($option) {
		file_put_contents("/tmp/apioption", $option);
		$ba = new beroAri();
		$ba->set('activate', $option);
	}

	/**
	 * Gibt das aktuelle activate level zurück
	 * @return int
	 */
	public static function getActivateOption() {
		$ba = new beroAri();
		return $ba->get("activate");
	}

	/**
	 * @return int Anzahl an Line interfaces
	 */
	public static function getLifCount() {
		return(trim(file_get_contents('/sys/class/beronet/gateway/li_count')));
	}

	/**
	 * Gibt den Namen des angefragen Line interfaces zurück
	 * @param int $LifIndex
	 * @return string
	 */
	public static function getLifName($LifIndex) {
		return(file_exists(self::getLifPath() . 'li' . $LifIndex . '/module') ? trim(@file_get_contents(self::getLifPath() . 'li' . $LifIndex . '/module')) : 'none');
	}

	/**
	 * Gibt den Namen aller Line interfaces zurück
	 * @return array
	 */
	public static function getLif() {
		for ($i = 0; $i < self::getLifCount(); $i++) {
			$li[$i] = self::getLifName($i);
		}
		return($li);
	}

	/**
	 * Gibt einen Pfad zurück
	 * @return string
	 */
	public static function getLifPath() {
		return (is_dir('/usr/conf/lif')) ? '/usr/conf/lif/' : '/sys/class/beronet/';
	}

	/**
	 * Return the specific FXO country setting for the given country $c
	 * @param string $c
	 * @return array
	 */
	public static function getCountrySetting($c = "1TR110_DE") {
		$country = array(
			"FCC" => array('ohs' => 0, 'ohs2' => 0, 'rz' => 0, "rt" => 1, "rt2" => 0, 'dcv' => '0x3', 'mini' => "0x0", 'ilim' => 0, 'acim' => '0x0'),
			"TRB21" => array('ohs' => 0, 'ohs2' => 0, 'rz' => 0, "rt" => 0, "rt2" => 0, 'dcv' => '0x3', 'mini' => "0x0", 'ilim' => 1, 'acim' => '0x2'),
			"ARGENTINA" => array('ohs' => 0, 'ohs2' => 0, 'rz' => 0, "rt" => 0, "rt2" => 0, 'dcv' => '0x3', 'mini' => "0x0", 'ilim' => 0, 'acim' => '0x0'),
			"AUSTRALIA" => array('ohs' => 1, 'ohs2' => 0, 'rz' => 0, "rt" => 0, "rt2" => 0, 'dcv' => '0x0', 'mini' => "0x3", 'ilim' => 0, 'acim' => '0x3'),
			"AUSTRIA" => array('ohs' => 0, 'ohs2' => 1, 'rz' => 0, "rt" => 0, "rt2" => 0, 'dcv' => '0x3', 'mini' => "0x0", 'ilim' => 1, 'acim' => '0x3'),
			"BAHRAIN" => array('ohs' => 0, 'ohs2' => 0, 'rz' => 0, "rt" => 0, "rt2" => 0, 'dcv' => '0x3', 'mini' => "0x0", 'ilim' => 1, 'acim' => '0x2'),
			"BELGIUM" => array('ohs' => 0, 'ohs2' => 1, 'rz' => 0, "rt" => 0, "rt2" => 0, 'dcv' => '0x3', 'mini' => "0x0", 'ilim' => 1, 'acim' => '0x2'),
			"BRAZIL" => array('ohs' => 0, 'ohs2' => 0, 'rz' => 0, "rt" => 0, "rt2" => 0, 'dcv' => '0x0', 'mini' => "0x3", 'ilim' => 0, 'acim' => '0x0'),
			"BULGARIA" => array('ohs' => 0, 'ohs2' => 0, 'rz' => 0, "rt" => 0, "rt2" => 0, 'dcv' => '0x3', 'mini' => "0x0", 'ilim' => 1, 'acim' => '0x3'),
			"CANADA" => array('ohs' => 0, 'ohs2' => 0, 'rz' => 0, "rt" => 0, "rt2" => 0, 'dcv' => '0x3', 'mini' => "0x0", 'ilim' => 0, 'acim' => '0x0'),
			"CHILE" => array('ohs' => 0, 'ohs2' => 0, 'rz' => 0, "rt" => 0, "rt2" => 0, 'dcv' => '0x3', 'mini' => "0x0", 'ilim' => 0, 'acim' => '0x0'),
			"CHINA" => array('ohs' => 0, 'ohs2' => 0, 'rz' => 0, "rt" => 0, "rt2" => 0, 'dcv' => '0x0', 'mini' => "0x3", 'ilim' => 0, 'acim' => '0xf'),
			"COLOMBIA" => array('ohs' => 0, 'ohs2' => 0, 'rz' => 0, "rt" => 0, "rt2" => 0, 'dcv' => '0x3', 'mini' => "0x0", 'ilim' => 0, 'acim' => '0x0'),
			"CROATIA" => array('ohs' => 0, 'ohs2' => 0, 'rz' => 0, "rt" => 0, "rt2" => 0, 'dcv' => '0x3', 'mini' => "0x0", 'ilim' => 1, 'acim' => '0x2'),
			"CYPRUS" => array('ohs' => 0, 'ohs2' => 0, 'rz' => 0, "rt" => 0, "rt2" => 0, 'dcv' => '0x3', 'mini' => "0x0", 'ilim' => 1, 'acim' => '0x2'),
			"CZECH" => array('ohs' => 0, 'ohs2' => 0, 'rz' => 0, "rt" => 0, "rt2" => 0, 'dcv' => '0x3', 'mini' => "0x0", 'ilim' => 1, 'acim' => '0x2'),
			"DENMARK" => array('ohs' => 0, 'ohs2' => 1, 'rz' => 0, "rt" => 0, "rt2" => 0, 'dcv' => '0x3', 'mini' => "0x0", 'ilim' => 1, 'acim' => '0x2'),
			"ECUADOR" => array('ohs' => 0, 'ohs2' => 0, 'rz' => 0, "rt" => 0, "rt2" => 0, 'dcv' => '0x3', 'mini' => "0x0", 'ilim' => 0, 'acim' => '0x0'),
			"EGYPT" => array('ohs' => 0, 'ohs2' => 0, 'rz' => 0, "rt" => 0, "rt2" => 0, 'dcv' => '0x3', 'mini' => "0x0", 'ilim' => 0, 'acim' => '0x0'),
			"ELSALVADOR" => array('ohs' => 0, 'ohs2' => 0, 'rz' => 0, "rt" => 0, "rt2" => 0, 'dcv' => '0x3', 'mini' => "0x0", 'ilim' => 0, 'acim' => '0x0'),
			"FINLAND" => array('ohs' => 0, 'ohs2' => 1, 'rz' => 0, "rt" => 0, "rt2" => 0, 'dcv' => '0x3', 'mini' => "0x0", 'ilim' => 1, 'acim' => '0x2'),
			"FRANCE" => array('ohs' => 0, 'ohs2' => 1, 'rz' => 0, "rt" => 0, "rt2" => 0, 'dcv' => '0x3', 'mini' => "0x0", 'ilim' => 1, 'acim' => '0x2'),
			"GERMANY" => array('ohs' => 0, 'ohs2' => 1, 'rz' => 0, "rt" => 0, "rt2" => 0, 'dcv' => '0x3', 'mini' => "0x0", 'ilim' => 1, 'acim' => '0x3'),
			"1TR110_DE" => array('ohs' => 0, 'ohs2' => 1, 'rz' => 0, "rt" => 1, "rt2" => 1, 'dcv' => '0x3', 'mini' => "0x0", 'ilim' => 1, 'acim' => '0x3'),
			"GREECE" => array('ohs' => 0, 'ohs2' => 1, 'rz' => 0, "rt" => 0, "rt2" => 0, 'dcv' => '0x3', 'mini' => "0x0", 'ilim' => 1, 'acim' => '0x2'),
			"GUAM" => array('ohs' => 0, 'ohs2' => 0, 'rz' => 0, "rt" => 0, "rt2" => 0, 'dcv' => '0x3', 'mini' => "0x0", 'ilim' => 0, 'acim' => '0x0'),
			"HONGKONG" => array('ohs' => 0, 'ohs2' => 0, 'rz' => 0, "rt" => 0, "rt2" => 0, 'dcv' => '0x3', 'mini' => "0x0", 'ilim' => 0, 'acim' => '0x0'),
			"HUNGARY" => array('ohs' => 0, 'ohs2' => 0, 'rz' => 0, "rt" => 0, "rt2" => 0, 'dcv' => '0x3', 'mini' => "0x0", 'ilim' => 0, 'acim' => '0x0'),
			"ICELAND" => array('ohs' => 0, 'ohs2' => 1, 'rz' => 0, "rt" => 0, "rt2" => 0, 'dcv' => '0x3', 'mini' => "0x0", 'ilim' => 1, 'acim' => '0x2'),
			"INDIA" => array('ohs' => 0, 'ohs2' => 0, 'rz' => 0, "rt" => 0, "rt2" => 0, 'dcv' => '0x3', 'mini' => "0x0", 'ilim' => 0, 'acim' => '0x4'),
			"INDONESIA" => array('ohs' => 0, 'ohs2' => 0, 'rz' => 0, "rt" => 0, "rt2" => 0, 'dcv' => '0x3', 'mini' => "0x0", 'ilim' => 0, 'acim' => '0x0'),
			"IRELAND" => array('ohs' => 0, 'ohs2' => 1, 'rz' => 0, "rt" => 0, "rt2" => 0, 'dcv' => '0x3', 'mini' => "0x0", 'ilim' => 1, 'acim' => '0x2'),
			"ISRAEL" => array('ohs' => 0, 'ohs2' => 0, 'rz' => 0, "rt" => 0, "rt2" => 0, 'dcv' => '0x3', 'mini' => "0x0", 'ilim' => 1, 'acim' => '0x2'),
			"ITALY" => array('ohs' => 0, 'ohs2' => 1, 'rz' => 0, "rt" => 0, "rt2" => 0, 'dcv' => '0x3', 'mini' => "0x0", 'ilim' => 1, 'acim' => '0x2'),
			"JAPAN" => array('ohs' => 0, 'ohs2' => 0, 'rz' => 0, "rt" => 0, "rt2" => 0, 'dcv' => '0x3', 'mini' => "0x0", 'ilim' => 0, 'acim' => '0x0'),
			"JORDAN" => array('ohs' => 0, 'ohs2' => 0, 'rz' => 0, "rt" => 0, "rt2" => 0, 'dcv' => '0x3', 'mini' => "0x0", 'ilim' => 0, 'acim' => '0x0'),
			"KAZAKHSTAN" => array('ohs' => 0, 'ohs2' => 0, 'rz' => 0, "rt" => 0, "rt2" => 0, 'dcv' => '0x3', 'mini' => "0x0", 'ilim' => 0, 'acim' => '0x0'),
			"KUWAIT" => array('ohs' => 0, 'ohs2' => 0, 'rz' => 0, "rt" => 0, "rt2" => 0, 'dcv' => '0x3', 'mini' => "0x0", 'ilim' => 0, 'acim' => '0x0'),
			"LATVIA" => array('ohs' => 0, 'ohs2' => 0, 'rz' => 0, "rt" => 0, "rt2" => 0, 'dcv' => '0x3', 'mini' => "0x0", 'ilim' => 1, 'acim' => '0x2'),
			"LEBANON" => array('ohs' => 0, 'ohs2' => 0, 'rz' => 0, "rt" => 0, "rt2" => 0, 'dcv' => '0x3', 'mini' => "0x0", 'ilim' => 1, 'acim' => '0x2'),
			"LUXEMBOURG" => array('ohs' => 0, 'ohs2' => 1, 'rz' => 0, "rt" => 0, "rt2" => 0, 'dcv' => '0x3', 'mini' => "0x0", 'ilim' => 1, 'acim' => '0x2'),
			"MACAO" => array('ohs' => 0, 'ohs2' => 0, 'rz' => 0, "rt" => 0, "rt2" => 0, 'dcv' => '0x3', 'mini' => "0x0", 'ilim' => 0, 'acim' => '0x0'),
			"MALAYSIA" => array('ohs' => 0, 'ohs2' => 0, 'rz' => 0, "rt" => 0, "rt2" => 0, 'dcv' => '0x3', 'mini' => "0x0", 'ilim' => 0, 'acim' => '0x0'),
			"MALTA" => array('ohs' => 0, 'ohs2' => 0, 'rz' => 0, "rt" => 0, "rt2" => 0, 'dcv' => '0x3', 'mini' => "0x0", 'ilim' => 1, 'acim' => '0x2'),
			"MEXICO" => array('ohs' => 0, 'ohs2' => 0, 'rz' => 0, "rt" => 0, "rt2" => 0, 'dcv' => '0x3', 'mini' => "0x0", 'ilim' => 0, 'acim' => '0x0'),
			"MOROCCO" => array('ohs' => 0, 'ohs2' => 0, 'rz' => 0, "rt" => 0, "rt2" => 0, 'dcv' => '0x3', 'mini' => "0x0", 'ilim' => 1, 'acim' => '0x2'),
			"NETHERLANDS" => array('ohs' => 0, 'ohs2' => 1, 'rz' => 0, "rt" => 0, "rt2" => 0, 'dcv' => '0x3', 'mini' => "0x0", 'ilim' => 1, 'acim' => '0x2'),
			"NEWZEALAND" => array('ohs' => 0, 'ohs2' => 0, 'rz' => 0, "rt" => 0, "rt2" => 0, 'dcv' => '0x3', 'mini' => "0x0", 'ilim' => 0, 'acim' => '0x4'),
			"NIGERIA" => array('ohs' => 0, 'ohs2' => 0, 'rz' => 0, "rt" => 0, "rt2" => 0, 'dcv' => '0x3', 'mini' => "0x0", 'ilim' => 1, 'acim' => '0x2'),
			"NORWAY" => array('ohs' => 0, 'ohs2' => 1, 'rz' => 0, "rt" => 0, "rt2" => 0, 'dcv' => '0x3', 'mini' => "0x0", 'ilim' => 1, 'acim' => '0x2'),
			"OMAN" => array('ohs' => 0, 'ohs2' => 0, 'rz' => 0, "rt" => 0, "rt2" => 0, 'dcv' => '0x3', 'mini' => "0x0", 'ilim' => 0, 'acim' => '0x0'),
			"PAKISTAN" => array('ohs' => 0, 'ohs2' => 0, 'rz' => 0, "rt" => 0, "rt2" => 0, 'dcv' => '0x3', 'mini' => "0x0", 'ilim' => 0, 'acim' => '0x0'),
			"PERU" => array('ohs' => 0, 'ohs2' => 0, 'rz' => 0, "rt" => 0, "rt2" => 0, 'dcv' => '0x3', 'mini' => "0x0", 'ilim' => 0, 'acim' => '0x0'),
			"PHILIPPINES" => array('ohs' => 0, 'ohs2' => 0, 'rz' => 0, "rt" => 0, "rt2" => 0, 'dcv' => '0x3', 'mini' => "0x0", 'ilim' => 0, 'acim' => '0x0'),
			"POLAND" => array('ohs' => 0, 'ohs2' => 0, 'rz' => 1, "rt" => 1, "rt2" => 0, 'dcv' => '0x3', 'mini' => "0x0", 'ilim' => 0, 'acim' => '0x0'),
			"PORTUGAL" => array('ohs' => 0, 'ohs2' => 1, 'rz' => 0, "rt" => 0, "rt2" => 0, 'dcv' => '0x3', 'mini' => "0x0", 'ilim' => 1, 'acim' => '0x2'),
			"ROMANIA" => array('ohs' => 0, 'ohs2' => 0, 'rz' => 0, "rt" => 0, "rt2" => 0, 'dcv' => '0x3', 'mini' => "0x0", 'ilim' => 0, 'acim' => '0x0'),
			"RUSSIA" => array('ohs' => 0, 'ohs2' => 0, 'rz' => 0, "rt" => 0, "rt2" => 0, 'dcv' => '0x3', 'mini' => "0x0", 'ilim' => 0, 'acim' => '0x0'),
			"SAUDIARABIA" => array('ohs' => 0, 'ohs2' => 0, 'rz' => 0, "rt" => 0, "rt2" => 0, 'dcv' => '0x3', 'mini' => "0x0", 'ilim' => 0, 'acim' => '0x0'),
			"SINGAPORE" => array('ohs' => 0, 'ohs2' => 0, 'rz' => 0, "rt" => 0, "rt2" => 0, 'dcv' => '0x3', 'mini' => "0x0", 'ilim' => 0, 'acim' => '0x0'),
			"SLOVAKIA" => array('ohs' => 0, 'ohs2' => 0, 'rz' => 0, "rt" => 0, "rt2" => 0, 'dcv' => '0x3', 'mini' => "0x0", 'ilim' => 0, 'acim' => '0x3'),
			"SLOVENIA" => array('ohs' => 0, 'ohs2' => 0, 'rz' => 0, "rt" => 0, "rt2" => 0, 'dcv' => '0x3', 'mini' => "0x0", 'ilim' => 0, 'acim' => '0x2'),
			"SOUTHAFRICA" => array('ohs' => 1, 'ohs2' => 0, 'rz' => 1, "rt" => 0, "rt2" => 0, 'dcv' => '0x3', 'mini' => "0x0", 'ilim' => 0, 'acim' => '0x3'),
			"SOUTHKOREA" => array('ohs' => 0, 'ohs2' => 0, 'rz' => 0, "rt" => 0, "rt2" => 0, 'dcv' => '0x3', 'mini' => "0x0", 'ilim' => 0, 'acim' => '0x0'),
			"SPAIN" => array('ohs' => 0, 'ohs2' => 1, 'rz' => 0, "rt" => 0, "rt2" => 0, 'dcv' => '0x3', 'mini' => "0x0", 'ilim' => 1, 'acim' => '0x2'),
			"SWEDEN" => array('ohs' => 0, 'ohs2' => 1, 'rz' => 0, "rt" => 0, "rt2" => 0, 'dcv' => '0x3', 'mini' => "0x0", 'ilim' => 1, 'acim' => '0x2'),
			"SWITZERLAND" => array('ohs' => 0, 'ohs2' => 1, 'rz' => 0, "rt" => 0, "rt2" => 0, 'dcv' => '0x3', 'mini' => "0x0", 'ilim' => 1, 'acim' => '0x2'),
			"SYRIA" => array('ohs' => 0, 'ohs2' => 0, 'rz' => 0, "rt" => 0, "rt2" => 0, 'dcv' => '0x3', 'mini' => "0x0", 'ilim' => 0, 'acim' => '0x0'),
			"TAIWAN" => array('ohs' => 0, 'ohs2' => 0, 'rz' => 0, "rt" => 0, "rt2" => 0, 'dcv' => '0x3', 'mini' => "0x0", 'ilim' => 0, 'acim' => '0x0'),
			"THAILAND" => array('ohs' => 0, 'ohs2' => 0, 'rz' => 0, "rt" => 0, "rt2" => 0, 'dcv' => '0x3', 'mini' => "0x0", 'ilim' => 0, 'acim' => '0x0'),
			"UAE" => array('ohs' => 0, 'ohs2' => 0, 'rz' => 0, "rt" => 0, "rt2" => 0, 'dcv' => '0x3', 'mini' => "0x0", 'ilim' => 0, 'acim' => '0x0'),
			"UK" => array('ohs' => 0, 'ohs2' => 1, 'rz' => 0, "rt" => 0, "rt2" => 0, 'dcv' => '0x3', 'mini' => "0x0", 'ilim' => 1, 'acim' => '0x5'),
			"USA" => array('ohs' => 0, 'ohs2' => 0, 'rz' => 0, "rt" => 0, "rt2" => 0, 'dcv' => '0x3', 'mini' => "0x0", 'ilim' => 0, 'acim' => '0x0'),
			"YEMEN" => array('ohs' => 0, 'ohs2' => 0, 'rz' => 0, "rt" => 0, "rt2" => 0, 'dcv' => '0x3', 'mini' => "0x0", 'ilim' => 0, 'acim' => '0x0'),
		);
		return $country[$c];
	}

	/**
	 * @return string Hardware revision
	 */
	public static function getRevision() {
		return(trim(file_get_contents('/sys/class/beronet/gateway/revision')));
	}

	/**
	 * @return string Serial number
	 */
	public static function getSerial() {
		return(trim(file_get_contents('/sys/class/beronet/gateway/serial')));
	}

	/**
	 * @return string Gateway type
	 */
	public static function getType() {
		return(trim(file_get_contents('/sys/class/beronet/gateway/type')));
	}

	/**
	 * @return int Gateway channels
	 */
	public static function getChannels() {
		return(trim(file_get_contents('/sys/class/beronet/gateway/channels')));
	}

	/**
	 * @return int Reset jumper connected or not
	 */
	public static function getResetJumper() {
		return(trim(file_get_contents('/sys/class/beronet/gateway/resetjumper')));
	}

	/**
	 * @return int fpga version
	 */
	public static function getFpgaVersion() {
		return(trim(file_get_contents('/sys/class/beronet/fpga/version')));
	}

	public static function getAppFsVersion() {
		$bc = new beroConf('root');
		preg_match('/appfs-(.*).tar.gz/', $bc->get('root', 'app-image'), $matches);
		return($matches[1]);
	}

	/**
	 * @return string rootfs version
	 */
	public static function getRootFsVersion() {
		$f = @file('/pkginfo/VERSION.rootfs');
		$tmp = explode('=', $f[1]);
		return(trim($tmp[1]));
	}

	/**
	 * @param string $Name
	 * @return string name of network interface
	 */
	public static function getNetworkIfaceByName($Name = 'lan') {
		$bc = new beroConf('root');

		$ports = $bc->get('root', 'lan-ports');
		$mode = $bc->get('root', 'lan-mode');
		$vlan['enable'] = $bc->get('root', 'vlan-enable');
		$vlan['id'] = $bc->get('root', 'vlan-id');

		switch ($Name) {
			case 'vpn':
				// lan interface is always 'tun0' if OpenVPN is installed
				if (file_exists('/apps/openvpn/VERSION')) {
					return('tun0');
				}
				break;
			case 'lan':
				switch ($mode) {
					default:
					case 'single':
						// vlan works as of now only on single iface-devices
						if (($vlan['enable'] == 1) && ($vlan['id'] > 0)) {
							return('eth0.' . $vlan['id']);
						}
					case 'lan-wan':
						return('eth0' . (($ports == 2) ? '.10' : ''));
					case 'bonding':
						return('eth0');
				}
				break;
			case 'wan':
				if ($mode == 'lan-wan') {
					return('eth0.11');
				}
				break;
		}

		return(false);
	}

	public static function getNetworkMacAddr($Iface = 'eth0') {
		return(trim(file_get_contents('/sys/class/net/' . $Iface . '/address')));
	}

	public static function getNetworkIpAddr($Iface = 'eth0') {
		return(exec('/usr/bin/expr match "$(/sbin/ifconfig ' . $Iface . ')" ".*inet addr:\([0-9\.]*\)"'));
	}

	public static function getNetworkMask($Iface = 'eth0') {
		return(exec('/usr/bin/expr match "$(/sbin/ifconfig ' . $Iface . ')" ".* Mask:\([0-9\.]*\)"'));
	}

	public static function getNetworkGateway($Iface = 'eth0') {
		return(exec('expr match "$(/sbin/route -n | grep ' . $Iface . ' | grep UG)" "0.0.0.0 *\([0-9\.]*\)"'));
	}

	public static function getNetworkInfo() {
		$bc = new beroConf('root');

		$info['ports'] = $bc->get('root', 'lan-ports');
		$info['mode'] = (strlen($bc->get('root', 'lan-mode')) ? $bc->get('root', 'lan-mode') : 'single');

		// get names of interfaces
		switch ($info['mode']) {
			case 'lan-wan':
				$wan_iface = 'eth0.11';
			case 'single':
				$lan_iface = 'eth0' . (($info['ports'] == 2) ? '.10' : '');
				break;
			case 'bonding':
				$lan_iface = 'eth0';
				break;
		}

		// get lan-info
		$info['iface']['lan']['macaddr'] = self::getNetworkMacAddr($lan_iface);
		$info['iface']['lan']['ipaddr'] = self::getNetworkIpAddr($lan_iface);
		$info['iface']['lan']['netmask'] = self::getNetworkMask($lan_iface);
		$info['iface']['lan']['gateway'] = self::getNetworkGateway($lan_iface);

		// get wan-info
		if ($info['mode'] == 'lan-wan') {
			$info['iface']['wan']['macaddr'] = self::getNetworkMacAddr($wan_iface);
			$info['iface']['wan']['ipaddr'] = self::getNetworkIpAddr($wan_iface);
			$info['iface']['wan']['netmask'] = self::getNetworkMask($wan_iface);
			$info['iface']['wan']['gateway'] = self::getNetworkGateway($wan_iface);
		}

		// get dns-config
		foreach (file('/etc/resolv.conf') as $line) {
			if (strstr($line, 'nameserver')) {
				$info['nameserver'][] = trim(substr($line, 10));
			}
		}

		return($info);
	}

	public static function getDate($formatString = null) {
		@exec('/bin/date ' . (($formatString != null) ? $formatString : '-R'), $output);
		return(trim($output[0]));
	}

	public static function getInfo() {
		// Serial
		$info['serial'] = self::getSerial();

		// AppFS Version
		$info['appfs'] = self::getAppFsVersion();

		// Root FS Version
		$info['rootfs'] = self::getRootFsVersion();

		// FPGA Version
		$info['fpga'] = self::getFpgaVersion();

		// HW Revision
		$info['hw_revision'] = self::getRevision();

		// Network
		$info['network'] = self::getNetworkInfo();

		// Date and time
		$info['date'] = self::getDate();

		//Lif
		$ba = new beroAri();
		for ($i = 0; $i < self::getLifCount(); $i++) {
			$query = $ba->select('SELECT type FROM isdn WHERE lif="' . $i . '" union ' .
				'SELECT type FROM analog WHERE lif="' . $i . '" union ' .
				'SELECT type FROM gsm WHERE lif="' . $i . '" union ' .
				'SELECT type FROM lte WHERE lif="' . $i . '" union ' .
				'SELECT type FROM cas WHERE lif="' . $i . '"');
			$type = sqlite_fetch_single($query);
			if (!empty($type)) {
				$info['lif' . $i] = 'li' . $i . ':  ' . $type;
			}
		}

		//ISGW Uptime
		require_once ('/usr/local/www/berogui/includes/isgwtelnet.php');
		$isgw = new isgwtelnet();
		$isgw->isgw_login();
		$isgw_uptime = $isgw->isgw_uptime();
		$isgw_uptime = preg_split("/: /", $isgw_uptime);
		$info['isgw_uptime'] = $isgw_uptime[1];
		//System Uptime
		exec('/usr/bin/uptime', $resup);
		preg_match("/(?<t>.+), load /", $resup[0], $uptime);
		$info['system_uptime'] = $uptime[t];
		$info['sip2sip_license_status'] = $isgw->isgw_siplicensestate();
		$info['sip2sip_number_of_licenses'] = $isgw->isgw_siplicensecount();

		//MSP Firmware
		$msp = explode(':', $isgw->Query('fw'));
		$info['msp_fw'] = $msp[1];


		return $info;
	}

	static public function getTotalCalls() {
		require_once ('/usr/local/www/berogui/includes/isgwtelnet.php');
		$isgw = new isgwtelnet();
		$result = $isgw->isgw_login();
		if ($result == false) {
			return 0;
		}
		$channelresult = $isgw->isgw_channelstate();
		$rows = explode("\n", $channelresult);
		$i = 0;
		$dontUse = array();
		foreach ($rows as $row) {
			$row = htmlspecialchars($row);
			$values = explode("\t", $row);
			if (trim($row) != "" && strpos($row, "LISTING CALL OPERATIONS COMPACT") === false && (!in_array(intval($values[0]), $dontUse))) {
				if (strpos($values[13], "MSP_BRIDGED") !== false) {
					/**
					 * PSTN zu PSTN Einträgen
					 */
					$tmp = explode("=", $values[10]);
					array_push($dontUse, intval($tmp[1]));
					$i++;
				} else {
					$i++;
				}
			}
		}
		return $i;
	}

	static public function getAppList() {
		$ret = array();
		if (!($dh = opendir('/home/admin/apps/'))) {
			return $ret;
		}

		while (($file = readdir($dh)) !== false) {
			if (($file == '.') || ($file == '..')) {
				continue;
			}
			$ret[] = $file;
		}
		closedir($dh);

		return $ret;
	}

	static public function getConfigFromIsgw() {
		exec("/usr/local/bin/isgw -C -e/usr/conf", $lines);
		reset($lines);
		while (strpos(current($lines), "Default call configuration:") === FALSE && current($lines) !== FALSE) {
			array_shift($lines);
		}
		array_shift($lines);
		return $lines;
	}

	static public function getDefaultConfig() {

		$lines = self::getConfigFromIsgw();
		$default = array();
		foreach ($lines as $line) {
			preg_match("/\[(?<bez>.+)\]\[(?<name>.+)\][\s]*(?<desc>.+)[\s]*\<(?<val>.*)\>[\s]*'(?<def>.*)'/", $line, $res);
			$default[$res["name"]] = $res['def'];
		}
		return $default;
	}

	static public function check(&$ba) {
		$query = $ba->select('SELECT DISTINCT gr FROM isdn WHERE gr!="NULL" union '
			. 'SELECT DISTINCT gr FROM analog WHERE gr!="NULL" union '
			. 'SELECT DISTINCT gr FROM gsm WHERE gr!="NULL" union '
			. 'SELECT DISTINCT gr FROM lte WHERE gr!="NULL" union '
			. 'SELECT DISTINCT gr FROM cas_channels WHERE gr!="NULL"');
		$pstn = sqlite_num_rows($query);
		$query = $ba->select('select * from sip');
		$sip = sqlite_num_rows($query);
		$query = $ba->select('select  * from dialplan');
		$dialplan = sqlite_num_rows($query);
		if ($pstn == 0 && $sip == 0 && $dialplan == 0) {
			return 1;
		} else {
			return 0;
		}
	}

}

?>
